import { Enum, ICronLikeJobs, ICronTypes, IDelayedJobs } from '../enums/types';
type Cron = Enum<ICronTypes>;
type Delayed = Enum<IDelayedJobs>;
type CronLike = Enum<ICronLikeJobs>;
export interface DelayedJobEvents extends Record<Delayed, {
    type: Delayed;
    data: any;
}> {
}
export interface CronLikeJobsEvents extends Record<CronLike, {
    type: CronLike;
    data: any;
}> {
}
type DelayedJobEvent = DelayedJobEvents[keyof DelayedJobEvents];
type CronLikeJobEvent = CronLikeJobsEvents[keyof CronLikeJobsEvents];
type DelayedJobCallback = (data: DelayedJobEvent) => Promise<void>;
type CronCallback = (name: ICronTypes[keyof ICronTypes]) => Promise<void>;
type CronLikeCallback = (data: CronLikeJobEvent) => Promise<void>;
export declare class BullJob {
    #private;
    constructor();
    addDelayedJob(data: DelayedJobEvent, delayInMs: number): Promise<string>;
    addCronLikeJob(data: CronLikeJobEvent, cron: string, tz?: string): Promise<string>;
    removeDelayedJob(jobId: string): Promise<void>;
    removeCronLikeJob(jobKey: string): Promise<void>;
    retryAllFailedJobs(): Promise<void>;
    startProcessingQueues(crons: {
        name: Cron | string;
        cron: string;
    }[], callbacks: {
        onDelayed?: DelayedJobCallback;
        onCron?: CronCallback;
        onCronLike?: CronLikeCallback;
    }): Promise<void>;
}
export {};
