import { createClient } from 'redis';
import { Cache } from '../cache';
export declare class RedisCache extends Cache {
    client: ReturnType<typeof createClient>;
    constructor();
    start(): Promise<void>;
    close(): Promise<void>;
    delete(key: string): Promise<void>;
    get(key: string): Promise<string | null>;
    set(key: string, data: string, ttlInSecs: number): Promise<void>;
    getOrSet<T>(key: string, fn: () => Promise<T>, ttlInSecs: number): Promise<any>;
}
