import mongoose from 'mongoose';
import { BaseEntity } from '../../structure';
import { Db, DbChangeCallbacks } from '../_instance';
import { QueryParams, QueryResults } from '../query';
import { MongoDbChange } from './changes';
export declare class MongoDb extends Db {
    #private;
    get Schema(): typeof mongoose.Schema;
    get Id(): mongoose.Types.ObjectId;
    use(dbName?: string): mongoose.Connection;
    change<Model, Entity extends BaseEntity<any, any>>(model: mongoose.Model<Model>, callbacks: DbChangeCallbacks<Model, Entity>, mapper: (model: Model | null) => Entity | null): MongoDbChange<Model, Entity>;
    query<Model>(model: mongoose.Model<Model>, params: QueryParams): Promise<QueryResults<Model>>;
    start(): Promise<void>;
    close(): Promise<void>;
}
