"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValidationError = void 0;
const server_1 = require("../../server");
const customError_1 = require("../customError");
class ValidationError extends customError_1.CustomError {
    statusCode = server_1.StatusCodes.ValidationError;
    constructor(errors) {
        super('Invalid request parameters', errors.map((e) => ({ field: e.field, message: e.messages.join('\n') })));
    }
}
exports.ValidationError = ValidationError;
