"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.exit = exports.addWaitBeforeExit = void 0;
const listeners = [];
const addWaitBeforeExit = (fn) => {
    listeners.unshift(fn);
};
exports.addWaitBeforeExit = addWaitBeforeExit;
const exit = (message) => {
    console.error(message);
    process.exit(1);
};
exports.exit = exit;
const signals = {
    SIGHUP: 1,
    SIGINT: 2,
    SIGTERM: 15
};
Object.entries(signals).forEach(([signal, code]) => {
    process.on(signal, async () => {
        await Promise.all(listeners.map(async (l) => {
            try {
                await typeof l === 'function' ? l() : l;
            }
            catch { }
        }));
        process.exit(128 + code);
    });
});
