import pino from 'pino';
import { BullJob } from '../bull';
import { Cache } from '../cache/cache';
import { RedisCache } from '../cache/types/redis-cache';
import { MongoDb } from '../db/mongoose';
import { EventBus } from '../events/';
import { Server } from '../server';
import { Settings } from './settings';
export declare class Instance {
    #private;
    private constructor();
    get logger(): pino.Logger<any, boolean>;
    get job(): BullJob;
    get cache(): Cache | RedisCache;
    get eventBus(): EventBus;
    get server(): Server<any, any>;
    get dbs(): {
        mongo: MongoDb;
    };
    get listener(): import("..").Listener;
    get settings(): Settings;
    static createLogger(): import("pino").Logger<any, boolean>;
    static initialize(settings: Partial<Settings>): void;
    static get(): Instance;
    startConnections(): Promise<void>;
}
