import { Level } from 'pino';
import type { ServerTypes } from '../server';
export type Settings = {
    accessTokenKey: string;
    accessTokenTTL: number;
    refreshTokenKey: string;
    refreshTokenTTL: number;
    debeziumUrl: string;
    mongoDbURI: string;
    rabbitURI: string;
    kafkaURIs: string[];
    redisURI: string;
    appId: string;
    bullQueueName: string;
    eventColumnName: string;
    maxFileUploadSizeInMb: number;
    useRateLimit: boolean;
    rateLimitPeriodInMs: number;
    rateLimit: number;
    useSlowDown: boolean;
    slowDownPeriodInMs: number;
    slowDownAfter: number;
    slowDownDelayInMs: number;
    hashSaltRounds: number;
    paginationDefaultLimit: number;
    server: ServerTypes;
    openapiDocsVersion: string;
    openapiDocsBaseUrl: string[];
    openapiDocsPath: string;
    logLevel: Level;
    logRequests: boolean;
    requestSchemaValidation: boolean;
};
export declare const defaulInstanceSetting: Settings;
