import io from 'socket.io';
import { BaseEntity } from '../structure';
import { AuthUser } from '../utils/authUser';
export type OnJoinFn = (data: {
    channel: string;
    user: AuthUser | null;
}, params: Record<string, any>, query: Record<string, any>) => Promise<string | null>;
export type SocketCallers = {
    onConnect: (userId: string, socketId: string) => Promise<void>;
    onDisconnect: (userId: string, socketId: string) => Promise<void>;
};
export declare class Listener {
    #private;
    constructor(socket: io.Server, callers: SocketCallers);
    start(): Promise<void>;
    created<T extends BaseEntity<any, any>>(channels: string[], data: T): Promise<void>;
    updated<T extends BaseEntity<any, any>>(channels: string[], { after, before }: {
        after: T;
        before: T;
    }): Promise<void>;
    deleted<T extends BaseEntity<any, any>>(channels: string[], data: T): Promise<void>;
    set callers(callers: SocketCallers);
    register(channel: string, onJoin?: OnJoinFn): this;
}
