import express from 'express';
import { Defined } from '../../types';
import { Request } from '../requests';
import { Route } from '../types';
import { FullRoute, Server } from './base';
export declare class ExpressServer extends Server<express.Request, express.Response> {
    #private;
    constructor();
    protected registerRoute(route: FullRoute): void;
    protected startServer(port: number): Promise<boolean>;
    protected onLoad(): Promise<void>;
    protected parse(req: express.Request): Promise<Request>;
    makeController(cb: Defined<Route['handler']>): (req: express.Request, res: express.Response, next: express.NextFunction) => Promise<void>;
    makeMiddleware(cb: Defined<Route['middlewares']>[number]['cb']): (req: express.Request, _res: express.Response, next: express.NextFunction) => Promise<void>;
    makeErrorMiddleware(cb: Defined<Route['onError']>['cb']): (err: Error, req: express.Request, res: express.Response, _next: express.NextFunction) => Promise<void>;
}
