import { FastifyReply, FastifyRequest, preHandlerHookHandler, RouteHandlerMethod } from 'fastify';
import { Defined } from '../../types';
import { Request } from '../requests';
import { Route } from '../types';
import { FullRoute, Server } from './base';
export declare class FastifyServer extends Server<FastifyRequest, FastifyReply> {
    #private;
    constructor();
    protected onLoad(): Promise<void>;
    protected registerRoute(route: FullRoute): void;
    protected startServer(port: number): Promise<boolean>;
    protected parse(req: FastifyRequest): Promise<Request<import("../types").Api<any, string, import("../types").MethodTypes, any, Record<string, string>, Record<string, any>, import("../types").HeadersType, import("../types").HeadersType, import("../types").SupportedStatusCodes>>>;
    makeController(cb: Defined<Route['handler']>): RouteHandlerMethod;
    makeMiddleware(cb: Defined<Route['middlewares']>[number]['cb']): preHandlerHookHandler<import("fastify").RawServerDefault, import("http").IncomingMessage, import("http").ServerResponse<import("http").IncomingMessage>, import("fastify").RouteGenericInterface, unknown, import("fastify").FastifySchema, import("fastify").FastifyTypeProviderDefault, import("fastify").FastifyBaseLogger>;
    makeErrorMiddleware(cb: Defined<Route['onError']>['cb']): (error: import("fastify").FastifyError, request: FastifyRequest, reply: FastifyReply) => void;
}
declare module 'fastify' {
    interface FastifyRequest {
        savedReq: Request | null;
    }
}
