"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.errorHandler = void 0;
const errors_1 = require("../../errors");
const instance_1 = require("../../instance");
const types_1 = require("../types");
exports.errorHandler = (0, types_1.makeErrorMiddleware)(async (req, error) => {
    if (error instanceof errors_1.CustomError)
        return req.error({
            body: error.serializedErrors,
            status: error.statusCode,
        });
    else {
        await instance_1.Instance.get().logger.error(error);
        return req.error({
            body: [{ message: 'Something went wrong', data: error.message }],
            status: types_1.StatusCodes.BadRequest,
        });
    }
});
