"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.parseAuthUser = void 0;
const errors_1 = require("../../errors");
const tokens_1 = require("../../utils/tokens");
const types_1 = require("../types");
exports.parseAuthUser = (0, types_1.makeMiddleware)(async (request) => {
    const accessToken = request.headers.AccessToken;
    if (accessToken)
        request.authUser = await (0, tokens_1.verifyAccessToken)(accessToken).catch((err) => {
            if (err instanceof errors_1.CustomError)
                request.pendingError = err;
            return null;
        });
});
