"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.requireAuthUser = void 0;
const errors_1 = require("../../errors");
const types_1 = require("../types");
exports.requireAuthUser = (0, types_1.makeMiddleware)(async (request) => {
    if (request.pendingError)
        throw request.pendingError;
    if (!request.headers.AccessToken)
        throw new errors_1.NotAuthenticatedError('Access-Token header missing');
    if (!request.authUser)
        throw new errors_1.NotAuthenticatedError();
}, (route) => {
    route.security ??= [];
    route.security.push({ AccessToken: [] });
    route.descriptions ??= [];
    route.descriptions.push('Requires a valid Access-Token header.');
});
