"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.requireRefreshUser = void 0;
const errors_1 = require("../../errors");
const tokens_1 = require("../../utils/tokens");
const types_1 = require("../types");
exports.requireRefreshUser = (0, types_1.makeMiddleware)(async (request) => {
    const refreshToken = request.headers.RefreshToken;
    if (!refreshToken)
        throw new errors_1.NotAuthorizedError('Refresh-Token header missing');
    request.refreshUser = await (0, tokens_1.verifyRefreshToken)(refreshToken);
    if (!request.refreshUser)
        throw new errors_1.NotAuthorizedError();
}, (route) => {
    route.security ??= [];
    route.security.push({ RefreshToken: [] });
    route.descriptions ??= [];
    route.descriptions.push('Requires a valid Refresh-Token header.');
});
