"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeErrorMiddleware = exports.makeMiddleware = exports.StatusCodes = exports.Methods = void 0;
exports.Methods = {
    get: 'get',
    post: 'post',
    put: 'put',
    patch: 'patch',
    delete: 'delete',
};
exports.StatusCodes = {
    Ok: 200,
    Found: 302,
    BadRequest: 400,
    NotAuthenticated: 401,
    NotAuthorized: 403,
    NotFound: 404,
    ValidationError: 422,
    TooManyRequests: 429,
    AccessTokenExpired: 461,
};
class MiddlewareHandler {
    cb;
    onSetup;
    constructor(cb, onSetup) {
        this.cb = cb;
        this.onSetup = onSetup;
    }
    static make(cb, onSetup) {
        return new MiddlewareHandler(cb, onSetup);
    }
}
const makeMiddleware = (...args) => MiddlewareHandler.make(...args);
exports.makeMiddleware = makeMiddleware;
const makeErrorMiddleware = (...args) => MiddlewareHandler.make(...args);
exports.makeErrorMiddleware = makeErrorMiddleware;
