"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseEntity = void 0;
const valleyed_1 = require("valleyed");
const utils_1 = require("../utils/utils");
const deleteKeyFromObject = (obj, keys) => {
    if (obj === undefined || obj === null)
        return;
    const isArray = Array.isArray(obj);
    if (keys.length === 1 && !isArray)
        return delete obj[keys[0]];
    if (isArray)
        return obj.map((v) => deleteKeyFromObject(v, keys));
    return deleteKeyFromObject(obj[keys[0]], keys.slice(1));
};
class BaseEntity extends valleyed_1.ClassPropertiesWrapper {
    __hash = utils_1.Random.string();
    __type = this.constructor.name;
    __ignoreInJSON = [];
    toJSON(includeIgnored = false) {
        const json = {};
        Object.keys(this)
            .concat(Object.getOwnPropertyNames(Object.getPrototypeOf(this)))
            .forEach((key) => {
            const value = this[key];
            if (typeof value === 'function')
                return;
            json[key] = value?.toJSON?.(includeIgnored) ?? (0, utils_1.clone)(value);
        });
        if (includeIgnored !== true)
            this.__ignoreInJSON.concat('__ignoreInJSON').forEach((k) => deleteKeyFromObject(json, k.split('.')));
        return json;
    }
    toString(includeIgnored = true) {
        return JSON.stringify(this.toJSON(includeIgnored), null, 2);
    }
}
exports.BaseEntity = BaseEntity;
