"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.retry = exports.sleep = void 0;
const sleep = (ms) => new Promise((resolve) => setTimeout(resolve, ms));
exports.sleep = sleep;
const retry = async (cb, trials, waitTimeInMs) => {
    trials -= 1;
    return await cb()
        .catch(async (err) => {
        if (trials <= 0)
            throw err;
        await (0, exports.sleep)(waitTimeInMs);
        return await (0, exports.retry)(cb, trials, waitTimeInMs);
    });
};
exports.retry = retry;
