import { AuthUser, RefreshUser } from './authUser';
export declare const makeAccessToken: (payload: AuthUser) => Promise<string>;
export declare const makeRefreshToken: (payload: RefreshUser) => Promise<string>;
export declare const verifyAccessToken: (token: string) => Promise<AuthUser>;
export declare const verifyRefreshToken: (token: string) => Promise<RefreshUser>;
export declare const getCachedAccessToken: (userId: string) => Promise<string | null>;
export declare const getCachedRefreshToken: (userId: string) => Promise<string | null>;
export declare const deleteCachedAccessToken: (userId: string) => Promise<void>;
export declare const deleteCachedRefreshToken: (userId: string) => Promise<void>;
type Tokens = {
    accessToken: string;
    refreshToken: string;
};
export declare const exchangeOldForNewTokens: ({ accessToken, refreshToken }: Tokens, makeTokens: (id: string) => Promise<Tokens>) => Promise<Tokens>;
export {};
